void setup() {
  pinMode(2, INPUT);            //Pin 2 auf Ausgang setzen
  digitalWrite(2, HIGH);        //Pullup-Widerstand einschalten
  Mouse.begin();                //Mauskontrolle übernehmen
}

bool StartKreis = false;
float GradZahl = 0;             //Aktuelle Position (Grad)
float SchrittWeite = 0.1;       //in Grad
double KreisDurchmesser = 100;  //300 Pixel Durchmesser
double XPos = 0;                //Aktuelle,  absolute Position (in Pixel)
double YPos = 0;
double AlteXPos = 0;            //Vorherige, absolute Position (in Pixel)
double AlteYPos = 0;

void loop() {
  if (digitalRead(2) == LOW)    //Bei Knopfdruck Vorgang starten
  {
    StartKreis = true;
  }

  if (StartKreis) {             //Wenn Vorgang gestartet ist
    //Berechnung der neuen Position
    GradZahl = GradZahl + SchrittWeite;
    XPos = round(sin(GradZahl) * KreisDurchmesser);
    YPos = round(cos(GradZahl) * KreisDurchmesser);
    // Maus an neue Position setzen
    Mouse.move(XPos - AlteXPos, YPos - AlteYPos, 0);
    AlteXPos = XPos;            //Aktuelle Position merken
    AlteYPos = YPos;
  }

  if (GradZahl > 2 * PI) {     //Nach einer Umdrehung anhalten
    GradZahl = 0;              //Position auf 0
    StartKreis = false;        //Vorgang beenden
    Mouse.end();               //Mauskontrolle wieder abgeben
  }

  delay(20);                   //Einige Millisekunden warten
}
