//Anschluss-Pin der Photodiode
const int Pin_Detektor = A0;

//Anschlusspin der IR-LED
const int Pin_LED = A2;

//Pin für die Kamera-Auslösung.
const int Pin_Kamera = 13;

//Schwellwert, ab dem die Lichtschranke als "offen" gilt.
//Muss experimentell ermittelt werden.
int Schwellwert = 130;

//Ist die Lichtschranke offen (kein Objekt in ihr)?
boolean Lichtschranke_offen;

void setup() {
  //Initialisiere die serielle Kommunikation.
  Serial.begin(9600);

  //Initialisiere die Fotodiode.
  pinMode(Pin_Detektor, INPUT);

  //Initialisiere die IR-LED.
  pinMode(Pin_LED, OUTPUT);
  digitalWrite(Pin_LED, LOW);

  //Initialisiere den Pin für den Kameraauslöser
  pinMode(Pin_Kamera, OUTPUT);
  digitalWrite(Pin_Kamera, LOW);

  //Initialisiere die onboard-LED, um den Zustand
  //der Lichtschranke anzuzeigen.
  pinMode(13, OUTPUT);
  digitalWrite(13, LOW);
}

void loop() {
  //Messe das Umgebungslicht.
  byte Messung_ohne_LED = analogRead(Pin_Detektor);
  digitalWrite(Pin_LED, HIGH);

  //Messe das Licht der IR-LED.
  byte Messung_mit_LED = analogRead(Pin_Detektor);
  digitalWrite(Pin_LED, LOW);
  
  //Überprüfe, ob die Lichtschranke geschlossen ist.
  if (Messung_mit_LED - Messung_ohne_LED > Schwellwert) {
    Lichtschranke_offen = true;
  } else {
    //Reagiere einmal, wenn sich die Lichtschranke schließt.
    if (Lichtschranke_offen) {
      reagiere();
    }
    Lichtschranke_offen = false;
  }

  //Lasse die onBoard-LED Leuchten, wenn sich etwas
  //in der Lichtschranke befindet.
  digitalWrite(13, !Lichtschranke_offen);
}

//Diese Methode wird ausgeführt, wenn
//die Lichtschranke geschlossen ist
void reagiere() {
  //Betätige den Kameraauslöser für 200 ms
  digitalWrite(Pin_Kamera, HIGH);
  delay(200);
  digitalWrite(Pin_Kamera, LOW);
}
