const int Pin_Motor = A5;
const int Pin_LDR = A0;
const int Pin_Sensor = A1;
const int Pin_Sensor_Vcc = A2;

const int Schwellwert_Nacht = 10;

void setup() {
  //Initialisiere die Pins
  pinMode(Pin_Motor, OUTPUT);
  pinMode(Pin_Sensor_Vcc, OUTPUT);
  digitalWrite(Pin_Motor, LOW);
  digitalWrite(Pin_Sensor_Vcc, HIGH);
  Serial.begin(9600);

  //Warte 10s, damit der Sensor eingestellt werden kann
  delay(10000);
}

void loop() {

  if (soll_gegossen_werden()) {
    Serial.println("Es wird gegossen");
    giesse(250);   //Gieße kurz
    delay(5000); //Warte ein par Sekunden
  }
}

void giesse(int Dauer) {
  digitalWrite(Pin_Motor, HIGH);
  delay(Dauer);
  digitalWrite(Pin_Motor, LOW);
}

boolean soll_gegossen_werden() {
  boolean tag = analogRead(Pin_LDR) > Schwellwert_Nacht;
  if (tag) {
    Serial.println("Es ist Tag.");
  } else {
    Serial.println("Es ist Nacht.");
  }
  
  if (tag) {
    digitalWrite(Pin_Sensor_Vcc, HIGH);
    delay(10);
    boolean trocken = digitalRead(Pin_Sensor);
    digitalWrite(Pin_Sensor_Vcc, LOW);
    
    if (trocken) {
      Serial.print("Die Erde ist trocken. ");
    } else {
      Serial.print("Die Erde ist feucht. ");
    }

    //Gieße, wenn die Erde tagsüber trocken ist
    if (trocken)
      return true;
  }

  return false;
}
