byte Led[20];              //Helligkeitswerte der LEDs

#define WECHSEL (60*1000L) //Animationswechsel alle 60 Sekunden
#define HERZSCHLAG (1250) //Ein Herzschlag dauert 1250 ms
#define MAXHELLIGKEIT 255  //Maximale Helligkeit (0-255)
#define GLUEHEFFEKT 6      //Ausblend-Geschwindigkeit

void setup()
{
  for (int i = 0; i <= 19; i++) {
    pinMode(i, OUTPUT);
  }
  LedsAktualisieren(MAXHELLIGKEIT);
}

void LedsAktualisieren(byte wert)
{
  for (int i = 0; i <= 19; i++) {
    Led[i] = wert;
  }
}

void loop()
{
  long Millisekunden = millis();

  //Animations-Wechsel
  if (Millisekunden % WECHSEL <= WECHSEL / 2) {
    //Herzschlag - Animation
    if (Millisekunden % HERZSCHLAG <= 20 ) {
      LedsAktualisieren(MAXHELLIGKEIT);
    }
    if ((Millisekunden % HERZSCHLAG >= HERZSCHLAG / 3 ) &&
        (Millisekunden % HERZSCHLAG <= HERZSCHLAG / 3 + 20)) {
      LedsAktualisieren(MAXHELLIGKEIT / 4 * 3);
    }
  } else {
    //Wandernder Punkt - Animation
    int aktuelleLed = (Millisekunden % 1000) / 50;
    Led[aktuelleLed] = MAXHELLIGKEIT;
  }

  //Software-PWM: Alles an
  for (int i = 0; i <= 19; i++) {
    if (Led[i] != 0 ) {
      digitalWrite(i, HIGH);
    }
  }
  //Software-PWM: Abschalten nach Ablauf der Zeit
  for (int z = 0; z <= 255; z++) {
    for (int i = 0; i <= 19; i++) {
      if (z == Led[i] ) {
        digitalWrite(i, LOW);
      }
    }
    delayMicroseconds(10);
  }

  //Helligkeit der einzelnen LEDs reduzieren
  for (int i = 0; i <= 19; i++) {
      Led[i] = max(0, Led[i] - GLUEHEFFEKT);
  }

}



