# -*- coding: utf-8 -*- 
#!/usr/bin/python
#------------------------------------------------------------------------   
# Robotik mit dem Raspberry Pi
# E.F.Engelhardt, Franzis Verlag, 2014 
# ----------------------------------------------------------------------- 
# Das Skript nutzt die Analog-Eingaenge des MCP3008 IC 
# und liest diese ueber SPI Bus aus
#
# joystick-analog-step1.py
# -----------------------------------------------------------------------
import spidev
# wget https://raw.github.com/doceme/py-spidev/master/setup.py
# wget https://raw.github.com/doceme/py-spidev/master/spidev_module.c
import time
import os
# SPI Objekt erstellen
spi = spidev.SpiDev()
spi.open(0,0)

# Funktion um Daten aus dem MCP3008 IC zu lesen
# Kanalzaehlung von 0-7
def getadcChannel(channel):
  # Nur Kanal 0-7 erlaubt
  if ((channel > 7) or (channel < 0)):
                    return -1
  rdata = spi.xfer2([1,(8+channel)<<4,0])
  data = ((rdata[1]&3) << 8) + rdata[2]
  return data

# Funktion um Werte in Spannungswerte zu konvertieren
# (auf 2^10 Einheiten)
def convertVolts(data,places):
  volts = (data * 3.3) / 1023 # 3.3V Referenzspannung an MCP!
  volts = round(volts,places) # und runden
  return volts
# ----------------------------------------------
# Start Python-Skript
# ----------------------------------------------
os.system('clear')
print "[Joystick-Analog] Raw / Voltwerte..." 
# Kanalnummer auswaehlen
VRx_channel = 5
VRy_channel = 6
# max 7 !
#
# Pause zwischen Messungen 
delay = 1 # 1 Sekunde
# dezimalstellen
places = 3
try: 
# Dauer-Schleife
  while True:
    os.system('clear')
    # Joystick VRx
    vrx_level = getadcChannel(VRx_channel)
    vrx_volts = convertVolts(vrx_level,places) 
    # Joystick VRy
    vry_level = getadcChannel(VRy_channel)
    vry_volts = convertVolts(vry_level,places)
    # Datenausgabe
    print "------------------------------------------------------------"  
    print("Joystick Variable X: {} ({}V)".format(vrx_level,vrx_volts))
    print("Joystick Variable Y: {} ({}V)".format(vry_level,vry_volts))
    time.sleep(delay)
except KeyboardInterrupt:
    # CTRL-C gedrueckt
    # Reset GPIO
    print "[Joystick] Messung abgebrochen."
# ----------------------- EOF  ---------------------------
