#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------
# Robotik mit dem Raspberry Pi
# E.F.Engelhardt, Franzis Verlag, 2014
# -----------------------------------------------------------------------
# pitouch-step01.py
# Pfad: /Touch-MRP121
#
import RPi.GPIO as GPIO
import mpr121
import os, sys
# Globals
# Use GPIO Interrupt Pin
TOUCH_GPIO=4 # GPIO4 = Pin 7
GPIO.setmode(GPIO.BCM)
GPIO.setup(TOUCH_GPIO, GPIO.IN)
touchPanel = mpr121.MPR121()
os.system("clear")
print "|--------------------------------------------|"
print "| [ MPR121 ] Touchpad wird initialisiert...  |"
touchArray = [0,0,0,0,0,0,0,0,0,0,0,0]
#
def main():
   try:
      while True:
         if (GPIO.input(TOUCH_GPIO)): # Interupt high
            pass
         else: # Interupt low
            touchData = touchPanel.readData()
            for i in range(12):
               if (touchData & (1<<i)):
                  if (touchArray[i] == 0):
                     print( '| [ MPR121 ] Pin-Nr. ' + str(i) + ' wird gedrueckt....    |')
                  touchArray[i] = 1;
               else:
                  if (touchArray[i] == 1):
                     print( '| [ MPR121 ] Pin-Nr. ' + str(i) + ' wurde "losgelassen"   |')
                  touchArray[i] = 0;
   except KeyboardInterrupt:
   # CTRL-C gedrueckt
   # Reset GPIO
      print "[ MPR121 ] Eingabe abgebrochen."
      GPIO.cleanup() # Aufraeumen !
# ---------------------------------------------------------------------
if __name__ == '__main__':
   main()
sys.exit(0)
# -----------------------------------------------------------------------
