#!/usr/bin/python
# -----------------------------------------------------------------------
# Robotik mit dem Raspberry Pi
# E.F.Engelhardt, Franzis Verlag, 2014
# -----------------------------------------------------------------------
# Funktion uln_full_half.py fuer uln2803-Schaltung bei
# unipolaren Steppermotoren
# Pfad: /motor
import time
import RPi.GPIO as gpio
# BCM GPIO Zaehlung aktiv
gpio.setmode(gpio.BCM)
# ------------------------------------------------
# Hier die genutzten GPIO
# Pins 10,12,11,15
# GPIO15,GPIO18,GPI17,GPI22
# fuer Stepper festlegen
#
motor_pins  = [15,22,18,17]
#  ------------------------------------------------
#  GPIO-Ausgaenge initialisieren
#
for s_pin in motor_pins:
  print "Initialisieren GPIOs fuer Motor: ", s_pin
  gpio.setup(s_pin,gpio.OUT)
  gpio.output(s_pin, False)
  print "  ---------------------------------------"
#  ------------------------------------------------
# Variablen definieren
#
# Schrittzaehler
stepCounter = 0
stepCounterSum = 0
stepCounterFull = 0
# Bei 1,8 Grad Schrittweite sind das 360/ 1,8 = 200 Schritte
stepCounter_full=200
wait = 0.5
#  ------------------------------------------------
# Umdrehung definieren - abwechselnd wird ein Pin
# eingeschaltet - Reihenfolge entspricht motor_pins
# Vollschrittverfahren
#
stepCount_full = 4
seq_full = []
seq_full = range(0, stepCount_full)
#  ------------------------------------------------
seq_full[0] = [0,1,0,0] # links, 22, Out 2
seq_full[1] = [0,0,1,0] # links, 18, Out 3
seq_full[2] = [0,0,0,1] # links, 17, Out 4
seq_full[3] = [1,0,0,0] # links, 15, Out 1
#  ------------------------------------------------
# Halbschrittverfahren
# [15,22,18,17]
stepCount_half = 8
seq_half = []
seq_half = range(0, stepCount_half)
seq_half[0] = [1,0,0,0]
seq_half[1] = [1,1,0,0]
seq_half[2] = [0,1,0,0]
seq_half[3] = [0,1,1,0]
seq_half[4] = [0,0,1,0]
seq_half[5] = [0,0,1,1]
seq_half[6] = [0,0,0,1]
seq_half[7] = [1,0,0,1]
#  ------------------------------------------------
# Vollschritt oder Halbschrittverfahren?
# Vollschritt = seq_full, stepCount_full
# Halbschritt = seq_half, stepCount_half
#seq = seq_full
seq = seq_half
#stepCount = stepCount_full
stepCount= stepCount_half
#  ------------------------------------------------
# Start und gleich in Schleife
try:
 while 1==1:
   for pin in range(0, 4):
    xpin = motor_pins[pin]
    if seq[stepCounter][pin]!=0:
      print " Step %i Enable %i Anzahl Steps %i Vollumdrehung %i" %(stepCounter,xpin,stepCounterSum,stepCounter) 
# fuer debug
#      if stepCounter==0:
#       print " Step 0 -> "
#      if stepCounter==1:
#        print " Step 1 -> "
#      if stepCounter==2:
#        print " Step 2 -> "
#      if stepCounter==3:
#        print " Step 3 -> "
      gpio.output(xpin, True)
    else:
      gpio.output(xpin, False)
   stepCounter += 1
   stepCounterSum += 1
   #  ------------------------------------------------
   # Ende Durchlauf erreicht - Neustart
   if (stepCounter==stepCount):
     stepCounter = 0
   if (stepCounter<0):
     stepCounter = stepCount
   if (stepCounterSum==stepCounter_full):
     stepCounterFull+= 1
     stepCounterSum=0
     print "Vollumdrehung, insgesamt Anzahl: ", stepCounterFull
   # Kurz warten
   time.sleep(wait)
except KeyboardInterrupt:
 gpio.cleanup()
#  ---------------------------------- EOF -----------------------------------------------
