#!/bin/bash
# ----------------------------------------------------
# Robotik mit dem Raspberry Pi
# E.F.Engelhardt, Franzis Verlag, 2014
# ----------------------------------------------------
# pantilt-cam.sh
# Pfad: /pwm-servo
#
time_intervall_ms=30000; # alle 5 minuten
time_intervall=`echo $time_intervall_ms/1000 | bc`;
ZAEHLERMAX=7
ZAEHLER=0;
ZAEHLERNEU=0;
FILE_PATH="/home/pi/IMG/";
FILEIMG="IMG_";
FILEEXTJPG=".jpg";
MOTOR0=0 # Anschluss 0
MOTOR1=1 # Anschluss 1
#-------------------------------------------------------------------------
function moveCam(){
    case "$ZAEHLERNEU" in
       0) 
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Startposition |"
            echo "---------------------------------------"
            # Schritt 0 (init)
            echo $MOTOR0=60 > /dev/servoblaster
            sleep 1
            echo $MOTOR1=135 > /dev/servoblaster
            sleep 1;;
        1)
            # Schritt 1
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Position 1   |"
            echo "---------------------------------------"
            echo $MOTOR0=240 > /dev/servoblaster
            sleep 1
            ;;
        2)
            # Schritt 2
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Position 2   |"
            echo "---------------------------------------"
            echo $MOTOR0=130 > /dev/servoblaster
            sleep 1
            ;;
        3)
            # Schritt 3
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Position 3   |"
            echo "---------------------------------------"
            echo $MOTOR0=60 > /dev/servoblaster
            sleep 1
            echo $MOTOR1=60 > /dev/servoblaster
            sleep 1
            ;;
        4)
            # Schritt 4
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Position 4   |"
            echo "---------------------------------------"
            echo $MOTOR1=140 > /dev/servoblaster
            sleep 1
            ;;
        5)
            # Schritt 5
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Position 5   |"
            echo "---------------------------------------"
            echo $MOTOR1=220 > /dev/servoblaster
            sleep 1
            ;;
        6)
            # Schritt 6
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Position 6   |"
            echo "---------------------------------------"
            echo $MOTOR1=220 > /dev/servoblaster
            sleep 1
            ;;
        7)
            #Schritt 7
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Position 7   |"
            echo "---------------------------------------"
            echo $MOTOR1=135 > /dev/servoblaster
            sleep 1
            ;;
        *)
            echo "---------------------------------------"
            echo "| [pantilt-cam] Fahre zu Startposition |"
            echo "---------------------------------------"
            # Schritt 0 (init)
            echo $MOTOR0=60 > /dev/servoblaster
            sleep 1
            echo $MOTOR1=135 > /dev/servoblaster
            sleep 1
            ;;
    esac
}
#-------------------------------------------------------------------------
function setnew_zaehler(){
    if [ "$(ls -A $FILE_PATH 2> /dev/null)" == "" ]; then 
        echo "[ pantilt-cam ] $FILE_PATH ist leer"; 
        ZAEHLERNEU=0;
        ZAEHLERAKTUELL=0;
    else 
        echo "[ pantilt-cam ] $FILE_PATH ist nicht leer";
        ZAEHLERAKTUELL=`ls -tr $FILE_PATH$FILEIMG* | tail -1 | cut -d '_' -f 2 | cut -d '.' -f 1`;
        if [ ! -z "$ZAEHLERAKTUELL" ]; then
            ZAEHLERNEU=`echo $ZAEHLERAKTUELL+1 | bc`;
        else
            ZAEHLERNEU=0;
        fi;
    fi;
}
#-------------------------------------------------------------------------
function takeSnapshot(){
    setnew_zaehler;
    FILENAMEIMG=$FILE_PATH$FILEIMG$ZAEHLERNEU$FILEEXTJPG;
        if [ -e  "/opt/vc/bin/raspistill" ]; then
            echo -e "[ pantilt-cam ] OK, raspistill ist installiert";
            raspistill -n -o $FILENAMEIMG # raspistill -n -o $FILENAMEIMG;
            echo "[ pantilt-cam ] Aufnahme:" $FILEIMG$ZAEHLERNEU$FILEEXTJPG " wurde auf der Speicherkarte gespeichert";
        else
            error_exit "[ pantilt-cam ] raspistill ist nichtinstalliert.. Keine Aufnahme moeglich!";
        fi;
}
#--------------------------------------------------------------------------
# main
clear
echo "[ pantilt-cam ] "`date +%s` "! pantilt-cam.sh"
rm -rf /home/pi/IMG
mkdir -p /home/pi/IMG
cd /home/pi
while [ $ZAEHLERNEU -le "$ZAEHLERMAX" ]; do
    moveCam;
    echo "[ pantilt-cam ] Aufnahme " $ZAEHLERNEU " wird erstellt ";
    takeSnapshot;
    sleep $time_intervall;
done
exit 0
# --------------------------- EOF ---------------------------------------

