# -*- coding: utf-8 -*-
#!/usr/bin/python
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2015
# -----------------------------------------------------------------------
# readekeyudp-step3.py
# Verzeichnis: /ekeyudp
#
import socket
import struct
from time import *
# -----------------------------------------------
localHost = ''
localPort = 56000
# ip address eKey udp converter
ekey = '192.168.123.250'
# port nummer UDP packet
ekeyPort = 56000
# delimiter eKey udp converter
ekeyDelimiter='#'
# mode RARE, MULTI, HOME
ekeyMode='HOME'
# in csv datei exportieren
fcsv = open("udpresults.csv", 'w')
fcsv.write("Benutzer, Finger, Aktion, Relais, Datum, Uhrzeit\n")
# ----------------------------------------------------------
s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
s.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
s.bind((localHost, localPort))
s.connect((ekey, ekeyPort))
#
try:
# Dauer-Schleife
   while True:
      print('Listening on {0}:{1} for traffic from {2}:{3}'.format(localHost, localPort, ekey, ekeyPort))
      data = s.recv(1024)
      print('Received: {0}'.format(data))
      print('Length UDP Paket: {0}'.format(len(data)))
      print('-------------------\n')
      if (len(data)==27):
         # 0 - PAKETTYP
         # 1 - ekeyDelimiter
         # 2-6 - Benutzernummer
         # 7 - ekeyDelimiter
         # 8 - FingerID
         # 9 - ekeyDelimiter
         # 10 - 23 SERIENNR 
         # 24 - ekeyDelimiter
         # 25 - AKTION
         # 26 - ekeyDelimiter
         # 27 - RELAIS
         lt = localtime()
         jahr, monat, tag = lt[0:3]
         paket = data.split(ekeyDelimiter)
         print '=' * 100
         datum = "%02i.%02i.%04i"  % (tag,monat,jahr)
         zeit =  strftime("%H:%M:%S", lt)
         print (">> Benutzer {0} mit Finger: {1} mit Aktion {2} an Relais:{3} am {4} um {5}".format(paket[1], paket[2], paket[4], paket[5], datum, zeit))
         fcsv.write("{0},{1},{2},{3}, {4},{5}\n".format(paket[1], paket[2], paket[4], paket[5], datum, zeit))
         print "Pakettyp (1-Daten): ", paket[0] # , "mit Finger: ", userFinger, "\n"
         print "Benutzernummer: ", paket[1] #
         print "Finger: ", paket[2] #
         print "Seriennummer: ", paket[3] #
         print "Aktion: ", paket[4] #
         print "an Relais Nr. ", paket[5] #
         print '=' * 100
         # in datei
      else:
         fcsv.close()
         s.close()      
         print "[ EKEY UDP ] Fehler im Datenstrom UDP-Port. -> Abbruch"
         exit()
except KeyboardInterrupt:
   fcsv.close()
   s.close()
   # CTRL-C gedrueckt
   print "[ EKEY UDP ] UDP-Port Lauschen wurde abgebrochen."
   print '=' * 100
# ----------------------- EOF  ---------------------------

