#!/usr/bin/python
# -*- coding: utf-8 -*-
#------------------------------------------------------------
# Python-Steuerung fuer Wifi-Lampen
# Datei : wifi-led.py
#------------------------------------------------------------
import time
from optparse import OptionParser
import wifileds
#------------------------------------------------------------
# ip adresse und port anpassen! 
wlan_ip_address='192.168.123.100'
udp_port='50000'
#------------------------------------------------------------
if __name__=="__main__":
    parser = OptionParser()
    parser.add_option('-a', '--address', default=wlan_ip_address, help='Wifi-Controller IP-Adresse')
    parser.add_option('-p', '--port', type='int', default=udp_port, help='Wifi-Controller IP-Adresse')
    (options, args) = parser.parse_args()
    print '=' * 80
    print 'Verbindung zur Wifi-Bridge wird aufgebaut...'
    led_connection = wifileds.limitlessled.connect(options.address, options.port)

    print 'Alle farbige Lampen werden eingeschaltet...'
    led_connection.rgb.all_on()

    print 'Hochdimmen...'
    led_connection.rgb.effect('fade_up')

    print 'Nochmals hochdimmen.....'
    time.sleep(1)
    led_connection.rgb.effect('fade_up')

    print 'Farbwechsel auf lila...'
    led_connection.rgb.set_color('lilac')
    time.sleep(1)

    print 'Farbwechsel nach gelb...'
    led_connection.rgb.set_color('yellow')
    time.sleep(1)

    print 'Herunterdimmen...'
    led_connection.rgb.effect('fade_down')

    print 'Und weiter herunter dimmen...'
    time.sleep(1)
    led_connection.rgb.effect('fade_down')

    print 'Wieder Helligkeit hochdrehen...'
    led_connection.rgb.effect('fade_up')

    print 'Strobe-Effekt farbig...'
    led_connection.rgb.effect('colorful_strobe')

    print 'Hoch und runterdimmen in kurzen Abstaenden...'
    led_connection.rgb.effect('fade_up')
    led_connection.rgb.effect('fade_down')
    led_connection.rgb.effect('fade_up')
    led_connection.rgb.effect('fade_down')

    print 'Polizei-Licht.....'
    led_connection.rgb.effect('police_flashers')

    print 'Pulsamoduliertes Licht in Gelb.. ..'
    led_connection.rgb.effect('pulsating_swells', effect_options={'duration': 15})

    print 'Effekt: Rainbow fade. Geschwindigkeit und Farben lassen sich ebenfalls anpassen......'
    led_connection.rgb.effect('rainbow_fade', effect_options={'delta': 5})

    print 'Strobe Effect abhaengig vom vorherigen Farbschema...'
    led_connection.rgb.effect('strobe', effect_options={'duration': 5})

    print 'Alle Lampen nochmals aus- und einschalten...'
    led_connection.rgb.all_off()
    time.sleep(1)
    led_connection.rgb.all_on()
    print '=' * 80
    print 'Falls einfarbige/weisse Lampen angeschlossen...\n'

    print 'Alle Einschalten...'
    led_connection.white.all_on()

    print 'Hoch und runterdimmenen der Lampen...'
    led_connection.white.effect('fade_up')
    led_connection.white.effect('fade_down')
    led_connection.white.effect('fade_up')
    led_connection.white.effect('fade_down')
    time.sleep(1)

    print '... und alle Lampen ausschalten...'
    led_connection.white.all_off()
    time.sleep(1)

    print 'Gruppensteuerung...'
    for i in range(1, 5):
        led_connection.white.zone_on(i)
        time.sleep(1)
    time.sleep(1)

    print 'Schlafmodus einschalten....'
    led_connection.white.nightlight_all()
    time.sleep(2)

    print 'Maximale Helligkeit aktivieren...'
    led_connection.white.full_all()
    time.sleep(2)

    print 'Max cool Farbtemperatur...'
    led_connection.white.max_cool()
    time.sleep(2)

    print 'Max warm Farbtemperatur ;)...'
    led_connection.white.max_warm()
    time.sleep(2)

    print 'Strobe Effekt...'
    led_connection.white.effect('strobe')

    print 'Das wars. Viel Spa!'
